%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%%%%%%%%%%%%%%%%%%%%%%%%	2D TOMOGRAPHY  %%%%%%%%%%%%%%%%%%%%%%%%%%  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  


if strcmpi(problem,'2D Tomography')
   snr = param.snr;
    if ~ismember(rad_line,[15 30])
        error('u:stuffed:it',['the parameters of your selected sampling coverage (%%) ' ...
               'do not exit! \n We have the parameters corresponding to 15%% '... 
               'and 30%% coverage of 3D FFT spectrum.\n ' ...
               'You can enter your own set of parameters here!'])
    elseif ~ismember(snr,[inf 20])
        error('u:stuffed:it',['the parameters of your selected SNR(dB) ratio ' ...
               'do not exit! \n We have the parameters corresponding to SNR = inf '... 
               'and SNR=20(dB).\n ' ...
               'You can enter your own set of parameters here!'])        
    end
        %%%%%%%%%%%%%%%%%%% Parameters for PnP-ADMM %%%%%%%%%%%%%%%%%%%%%%%   
    if strcmpi(PnP_framework,'ADMM') ==1         %%% PnP-ADMM
 
if     strcmpi(thr_setting,'W1')
    lambda        = 2.7;
    if rad_line ==15
        if snr == inf, mu = 1e-4; elseif snr == 20, mu = 140;  end
    elseif rad_line ==30
        if snr == inf, mu = 2e-5; elseif snr == 20, mu = 150;  end
    end
elseif strcmpi(thr_setting,'W1*')
    if rad_line ==15
        if snr == inf, lambda = 6.6; mu = 0.088; elseif snr == 20, lambda = 3.2; mu = 0.04; end
    elseif rad_line ==30
        if snr == inf, lambda = 6;   mu = 0.2;   elseif snr == 20, lambda = 3.2; mu = 0.13; end
    end
elseif strcmpi(thr_setting,'W2*')
     lambda       = 2.7;
     if rad_line ==15
         if snr == inf, gamma = 738.1125; mu = 4e-3; elseif snr==20, gamma = 8.4701e+04; mu = 0.22; end
     elseif rad_line ==30
         if snr == inf, gamma = 72.9000;  mu = 8e-3; elseif snr==20, gamma = 5.6953e+04; mu = 0.25; end
     end
     param.gamma = gamma; clear gamma
elseif strcmpi(thr_setting,'C')
    lambda        = 2.7;
    if rad_line ==15
        if snr == inf, mu = 0.35; elseif snr==20, mu = 1e-3; end
    elseif rad_line ==30
        if snr == inf, mu = 0.95; elseif snr==20, mu = 0.05; end
    end
elseif strcmpi(thr_setting,'C*')
    if rad_line ==15
        if snr == inf, mu = 0.06; lambda = 3.6; elseif snr==20, mu = 0.01; lambda  = 2.8; end
    elseif rad_line ==30
        if snr == inf, mu = 0.1;  lambda = 4.6; elseif snr==20, mu = 0.11; lambda  = 2.9; end
    end
   
else
            error(['your selected threshold setting %s does not exist! Please check the '...
                '<a href="matlab:help Reproduce_Table_II__2D_Tomography">syntax</a>'], ...
                thr_setting)
end
     rho = 1/mu; 

    elseif strcmpi(PnP_framework,'ISTA')
%%%%%%%%%%%%%%%%%%% Parameters for PnP-ISTA %%%%%%%%%%%%%%%%%%%%%%%
        if     strcmpi(thr_setting,'W1')
            lambda        = 2.7;
            if rad_line ==15
                if snr == inf, rho = 1.88; elseif snr == 20, rho = 0.007; end
            elseif rad_line ==30
                if snr == inf, rho = 1.92; elseif snr == 20, rho = 0.007; end
            end
        elseif strcmpi(thr_setting,'W1*')
            if rad_line ==15
                if snr == inf, lambda = 10.4; rho = 1.96; elseif snr == 20, lambda = 4.6; rho = 1.96; end
            elseif rad_line ==30
                if snr == inf, lambda = 6.4;  rho = 1.95; elseif snr == 20, lambda = 4;   rho = 1.9;  end
            end
        elseif strcmpi(thr_setting,'W2*')
            lambda       = 2.7;
            if rad_line ==15
                if snr == inf, gamma = 7.3266e+04; rho = 1.99; elseif snr==20, gamma = 2.9455e+05; rho = 1.98; end
            elseif rad_line ==30
                if snr == inf, gamma = 9.0205e+03; rho = 1.98; elseif snr==20, gamma = 1.4136e+05; rho = 1.95; end
            end
            param.gamma = gamma; clear gamma
        elseif strcmpi(thr_setting,'C')
            lambda        = 2.7;
            if rad_line ==15
                if snr == inf, rho = 1.3;  elseif snr==20, rho = 1.99; end
            elseif rad_line ==30
                if snr == inf, rho = 0.75; elseif snr==20, rho = 1.9;  end
            end
        elseif strcmpi(thr_setting,'C*')
            if rad_line ==15
                if snr == inf, rho = 1.98; lambda = 3.6; elseif snr==20, rho = 1.97; lambda = 3.5; end
            elseif rad_line ==30
                if snr == inf, rho = 1.97; lambda = 4.8; elseif snr==20, rho = 1.86; lambda = 3.4; end
            end
        else
            error(['your selected threshold setting %s does not exist! Please check the '...
                '<a href="matlab:help Reproduce_Table_II__2D_Tomography">syntax</a>'], ...
                thr_setting)
        end
              
    else
       error(['The parameters corresponding to the selected PnP framework %s '...
              'does not exist! \n Please check the ' ...
              '<a href="matlab:help Reproduce_Table_II__2D_Tomography">syntax</a>'],...
              PnP_framework)
 
    end
    param.lambda = lambda; 
    clear lambda mu snr
end




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%%%%%%%%%%%%%%%%%%%%%%%%	3D TOMOGRAPHY  %%%%%%%%%%%%%%%%%%%%%%%%%%  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 


if strcmpi(problem,'3D Tomography')
    
   snr = param.snr;
   if ~ismember(samp_cvg,[15 30])
       error('u:stuffed:it',['the parameters of your selected sampling coverage (%%) ' ...
           'does not exit! \n We have the parameters corresponding to 15%% '...
           'and 30%% coverage of 3D FFT spectrum.\n ' ...
           'You can enter your own set of parameters here!'])
   elseif ~ismember(snr,[inf 20])
       error('u:stuffed:it',['the parameters of your selected SNR(dB) ratio ' ...
           'do not exit! \n We have the parameters corresponding to SNR = inf '...
           'and SNR=20(dB).\n ' ...
           'You can enter your own set of parameters here!'])
   end
        %%%%%%%%%%%%%%%%%%% Parameter for PnP-ADMM %%%%%%%%%%%%%%%%%%%%%%%
    if strcmpi(PnP_framework,'ADMM') ==1         %%% PnP-ADMM
        
        if     strcmpi(thr_setting,'W1')
            lambda        = 2.7;
            if samp_cvg == 15
                if snr == inf, mu = 1e-4;  elseif snr == 20, mu = 250;  end
            elseif samp_cvg == 30
                if snr == inf, mu = 1e-4;  elseif snr == 20, mu = 1e-4;  end
            end
        elseif strcmpi(thr_setting,'W1*')
            if samp_cvg == 15
                if snr == inf, lambda = 8; mu = 9e-3; elseif snr == 20, lambda = 3.2; mu = 0.06; end
            elseif samp_cvg == 30
                if snr == inf, lambda = 6; mu = 2e-2; elseif snr == 20, lambda = 3.4; mu = 0.18; end
            end
        elseif strcmpi(thr_setting,'W2*')
            lambda       = 2.7;
            if samp_cvg == 15
                if snr == inf, gamma = 0.0536; mu = 1e-4; elseif snr==20, gamma = 1.9047e+04; mu = 0.8;  end
            elseif samp_cvg == 30
                if snr == inf, gamma = 0.0238; mu = 1e-4; elseif snr==20, gamma = 2.2618e+04; mu = 0.95; end
            end
            param.gamma = gamma; clear gamma
        elseif strcmpi(thr_setting,'C')
            lambda        = 2.7;
            if samp_cvg == 15
                if snr == inf, mu = 0.75; elseif snr==20, mu = 0.22; end
            elseif samp_cvg == 30
                if snr == inf, mu = 1.6;  elseif snr==20, mu = 0.36;  end
            end
        elseif strcmpi(thr_setting,'C*')
            if samp_cvg == 15
                if snr == inf, mu = 0.08; lambda = 4.2; elseif snr==20, mu = 0.22; lambda  = 2.7; end
            elseif samp_cvg == 30
                if snr == inf, mu = 0.1;  lambda = 4.8; elseif snr==20, mu = 0.36; lambda  = 2.7; end
            end
            
        else
            error(['your selected threshold setting %s does not exist! Please check the '...
                '<a href="matlab:help Reproduce_Table_III__3D_Tomography">syntax</a>'], ...
                thr_setting)
        end
        rho = 1/mu;
        
    elseif strcmpi(PnP_framework,'ISTA') ==1 
        %%%%%%%%%%%%%%%%%%% Parameter for PnP-ISTA %%%%%%%%%%%%%%%%%%%%%%%
        if     strcmpi(thr_setting,'W1')
            lambda        = 2.7;
            if samp_cvg == 15
                if snr == inf, rho = 1.95; elseif snr == 20, rho = 5e-3; end
            elseif samp_cvg == 30
                if snr == inf, rho = 1.98; elseif snr == 20, rho = 1.98; end
            end
        elseif strcmpi(thr_setting,'W1*')
            if samp_cvg == 15
                if snr == inf, lambda = 10;  rho = 1.91; elseif snr == 20, lambda = 4.6; rho = 1.93; end
            elseif samp_cvg == 30
                if snr == inf, lambda = 7.5; rho = 1.98; elseif snr == 20, lambda = 4.4; rho = 1.4; end
            end
        elseif strcmpi(thr_setting,'W2*')
            lambda       = 2.7;
            if samp_cvg == 15
                if snr == inf, gamma = 281.9416; rho = 1.9;  elseif snr==20, gamma = 3.5713e+04; rho = 1.5; end
            elseif samp_cvg == 30
                if snr == inf, gamma = 124.6513; rho = 1.91; elseif snr==20, gamma = 2.3808e+04; rho = 1;   end
            end
            param.gamma = gamma; clear gamma
        elseif strcmpi(thr_setting,'C')
            lambda        = 2.7;
            if samp_cvg == 15
                if snr == inf, rho = 0.85; elseif snr==20, rho = 1.98; end
            elseif samp_cvg == 30
                if snr == inf, rho = 0.5;  elseif snr==20, rho = 1.86;  end
            end
        elseif strcmpi(thr_setting,'C*')
            if samp_cvg == 15
                if snr == inf, rho = 1.96; lambda = 4.1; elseif snr==20, rho = 1.97; lambda  = 3.0; end
            elseif samp_cvg == 30
                if snr == inf, rho = 1.93; lambda = 5.3; elseif snr==20, rho = 1.86; lambda  = 2.7; end
            end
        else
            error(['your selected threshold setting %s does not exist! Please check the '...
                '<a href="matlab:help Reproduce_Table_III__3D_Tomography">syntax</a>'], ...
                thr_setting)
        end
        
    else
        error(['The parameters corresponding to the selected PnP framework %s '...
            'does not exist! \n Please check the ' ...
            '<a href="matlab:help Reproduce_Table_III__3D_Tomography">syntax</a>'],...
            PnP_framework)
        
    end

    param.lambda = lambda;
    clear lambda mu snr
end




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%%%%%%%%%%%%%%%%%% COMPRESSIVE SPECTRAL IMAGING %%%%%%%%%%%%%%%%%%%%  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 


if strcmpi(problem,'Compressive Spectral Imaging')
    snr = param.snr;
    if ~ismember(snr,[inf 25 15])
        error('u:stuffed:it',['the parameters of your selected SNR(dB) ratio ' ...
               'do not exit! \n We have the parameters corresponding to SNR = inf '... 
               'SNR=25(dB) and 15(dB).\n ' ...
               'You can enter your own set of parameters here!']) 
    end
%%%%%%%%%%%%%%%%%%% Parameter for PnP-ADMM %%%%%%%%%%%%%%%%%%%%%%%    
    if strcmpi(PnP_framework,'ADMM') ==1    %% PnP-ADMM
        
        if     strcmpi(thr_setting,'W1')
            lambda = 3.7;
            if       snr == inf
                rho = 1e3;  
            elseif   snr == 25
                rho = 200;  
            elseif   snr == 15
                rho = 100; 
            end
        elseif strcmpi(thr_setting,'W1*')
            if       snr == inf
                rho = 1/.05;    lambda = 9.5;
            elseif   snr == 25
                rho = 1/.2;     lambda = 8;
            elseif   snr == 15
                rho = 1/.5;     lambda = 7.8;
            end
        elseif strcmpi(thr_setting,'W2*')
            lambda = 3.7;
            if       snr == inf
                rho = 1/.03;    gamma = 3.2856e+06;
            elseif   snr==25
                rho = 1/.3;     gamma = 1.8481e+07;
            elseif   snr==15
                rho = 1/.8;     gamma = 4.9284e+07;
            end
            param.gamma = gamma; clear gamma
        elseif strcmpi(thr_setting,'C')
            lambda = 3.7;
            if       snr == inf
                rho = 1/.03;
            elseif   snr == 25
                rho = 1/.25;
            elseif   snr == 15
                rho = 1/1.1;
            end
        elseif strcmpi(thr_setting,'C*')
            if       snr == inf
                rho = 1/.03;    lambda = 3.7;
            elseif   snr == 25
                rho = 1/.25;    lambda = 3.7;
            elseif   snr == 15
                rho = 1/1.1;    lambda = 3.7;
            end
        else
            error(['your selected threshold setting %s does not exist! Please check the '...
                '<a href="matlab:help Reproduce_Table_I__Compressive_Spectral_Imaging">syntax</a>'], ...
                thr_setting)
        end

%%%%%%%%%%%%%%%%%%% Parameter for PnP-ISTA %%%%%%%%%%%%%%%%%%%%%%%         
    elseif strcmpi(PnP_framework,'ISTA') ==1    %% PnP-ISTA
        
        if     strcmpi(thr_setting,'W1')
            lambda = 3.7;
            if       snr == inf
                rho = 1.7;
            elseif   snr == 25
                rho = 1.8;
            elseif   snr == 15
                rho = 1.6;
            end
        elseif strcmpi(thr_setting,'W1*')
            if       snr == inf
                rho = 2;        lambda = 18;
            elseif   snr == 25
                rho = 1.98;     lambda = 10.3;
            elseif   snr == 15
                rho = 1.8;      lambda = 7.8;
            end
        elseif strcmpi(thr_setting,'W2*')
            lambda = 3.7;
            if       snr == inf
                rho = 2;        gamma  = 1.7326e7;
            elseif   snr==25
                rho = 2;        gamma  = 1.3690e7;
            elseif   snr==15
                rho = 1.75;     gamma  = 7.9206e7;
            end
            param.gamma = gamma; clear gamma            
        elseif strcmpi(thr_setting,'C')
            lambda = 3.7;
            if       snr == inf
                rho = 1.2;
            elseif   snr == 25
                rho = 2;
            elseif   snr==15
                rho = .9;
            end
        elseif strcmpi(thr_setting,'C*')
            if       snr == inf
                rho = 1.94;      lambda = 4.9;
            elseif   snr == 25
                rho = 1.99;      lambda = 4.5;
            elseif   snr==15
                rho = 1.05;      lambda = 4.3;
            end
        else
            error(['your selected threshold setting %s does not exist! Please check the '...
                '<a href="matlab:help Reproduce_Table_I__Compressive_Spectral_Imaging">syntax</a>'], ...
                thr_setting)
        end
    else
        error(['The parameters corresponding to the selected PnP framework %s '...
            'does not exist! \n Please check the ' ...
            '<a href="matlab:help Reproduce_Table_I__Compressive_Spectral_Imaging">syntax</a>'],...
            PnP_framework)
    end
    
    param.lambda = lambda; clear lambda snr gamma
end







%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%%%%%%%%%%%%%%%%%% COMPRESSIVE TEMPORAL IMAGING %%%%%%%%%%%%%%%%%%%%  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 



if strcmpi(problem,'Compressive Temporal Imaging')
    snr = param.snr;
    if ~ismember(snr,[inf 15])
        error('u:stuffed:it',['the parameters of your selected SNR(dB) ratio ' ...
               'do not exit! \n We have the parameters corresponding to SNR = inf '... 
               'and 15(dB).\n ' ...
               'You can enter your own set of parameters here!']) 
    end
   
        %%%%%%%%%%%%%%%%%%% Parameters for PnP-ADMM %%%%%%%%%%%%%%%%%%%%%%%   
    if strcmpi(PnP_framework,'ADMM') ==1          %%% PnP-ADMM
    
        if     strcmpi(thr_setting,'W1')
            lambda = 2.7;
            if snr == inf, mu = 1e-3;                elseif snr == 15, mu = 8; end

        elseif strcmpi(thr_setting,'W1*')
            if snr == inf, mu = .6; lambda = 6;      elseif snr == 15, mu = 6.4; lambda = 5.4; end

        elseif strcmpi(thr_setting,'W2*')
            lambda = 2.7;
            if snr == inf, mu = .07; gamma = 9.1854; elseif snr == 15, mu = 5.6; gamma = 1.3064e+03; end
            param.gamma = gamma; clear gamma
        elseif strcmpi(thr_setting,'C')
            lambda = 2.7;
            if snr == inf, mu = 1e-4;                elseif snr == 15, mu = 1.1; end
        elseif strcmpi(thr_setting,'C*')
            lambda = 2.7;
            if snr == inf, mu = 1e-4;                elseif snr == 15, mu = 1.1; end 

        else
            error(['your selected threshold setting %s does not exist! Please check the '...
                '<a href="matlab:help Reproduce_Fig_6__Compressive_Temporal_Imaging">syntax</a>'], ...
                thr_setting)
        end
    rho = 1/mu; clear mu
    
        %%%%%%%%%%%%%%%%%%% Parameters for PnP-ISTA %%%%%%%%%%%%%%%%%%%%%%%   
    elseif strcmpi(PnP_framework,'ISTA') ==1          %%% PnP-ISTA
    
        if     strcmpi(thr_setting,'W1')
            lambda = 2.7;
            if snr == inf, rho = 1.99;               elseif snr == 15, rho = 2; end

        elseif strcmpi(thr_setting,'W1*')
            if snr == inf, rho = 1.9; lambda = 8;    elseif snr == 15, rho = .55; lambda = 5.1; end

        elseif strcmpi(thr_setting,'W2*')
            lambda = 2.7;
            if snr == inf, rho = 2; gamma = 45.5625; elseif snr == 15, rho = .85; gamma = 347.3471; end
            param.gamma = gamma; clear gamma
        elseif strcmpi(thr_setting,'C')
            lambda = 2.7; 
            if snr == inf, rho = 1.88;               elseif snr == 15, rho = .94; end

        elseif strcmpi(thr_setting,'C*')
            if snr == inf, rho = 2.01; lambda = 5;   elseif snr == 15, rho = .94; lambda = 2.7; end 

        else
            error(['your selected threshold setting %s does not exist! Please check the '...
                '<a href="matlab:help Reproduce_Fig_6__Compressive_Temporal_Imaging">syntax</a>'], ...
                thr_setting)
        end
    
    else
        error(['The parameters corresponding to the selected PnP framework %s '...
            'does not exist! \n Please check the ' ...
            '<a href="matlab:help Reproduce_Fig_6__Compressive_Temporal_Imaging">syntax</a>'],...
            PnP_framework)
    end
    
param.lambda = lambda; clear lambda snr gamma

end

